DIM config_manager
DIM admin_role

FUNCTION InitObject()
  SET config_manager = CreateObject("Microsoft.RightsManagementServices.Admin.ConfigurationManager")
  If IsNull(config_manager) Then
    InitObject = GenErrXML("Fail to create object: Microsoft.RightsManagementServices.Admin.ConfigurationManager.")
    Exit Function
  End If
 
  admin_role = config_manager.Initialize(false,"localhost",80,"","","")
  If IsNull(admin_role) Then
    InitObject = GenErrXML("Fail to initialize configuration manager.")
    Exit Function
  End If
  InitObject = ""
END FUNCTION

FUNCTION GetOfficialTemplateList()

  resultInit = InitObject()
  If resultInit <> "" Then
    GetOfficialTemplateList = resultInit
    Exit Function
  End If

  DIM templateMgr
  DIM templateColl
  DIM templateObj

  SET templateMgr = config_manager.RightsTemplatePolicy

  SET templateColl = templateMgr.RightsTemplateCollection
  If IsNull(templateColl) Then
    GetOfficialTemplateList = GenErrXML("Fail to get rights template collection.")
    Exit Function
  End If

  Set xmlDoc = CreateObject("Microsoft.XMLDOM")
  Set objRoot = xmlDoc.createElement("TemplateList")  
  xmlDoc.appendChild objRoot

  DIM nCount
  nCount = templateColl.Count
  For i=0 to nCount-1
    SET templateObj = templateColl.Item(i)

    DIM templateName
    DIM templateDes
    templateName = templateObj.Summaries.Item(0).Name
    templateDes = templateObj.Summaries.Item(0).Description

    If StrComp(templateName, "anyoneview", 1) <> 0 Then
        DIM templateExtData
        templateExtData = ""
        DIM templateDWMData
        templateDWMData = ""
        DIM templateDWMName
        templateDWMName = ""
        DIM appDataItems
        SET appDataItems = templateObj.ApplicationSpecificDataItems
        DIM nAppDataCount
        nAppDataCount = appDataItems.Count
        For j=0 to nAppDataCount-1
          SET appDataItem = appDataItems.Item(j)
          DIM appDataName
          appDataName = appDataItem.Name
          If StrComp(appDataName, "FXRMSExtension", 1) = 0 Then
            templateExtData = appDataItem.Value
          End If
          If InStr(appDataName, "FXRMSDWM-") Then
            templateDWMData = appDataItem.Value
            templateDWMName = appDataItem.Name
          End If
        Next    

        Set eleTemplate = xmlDoc.createElement("Template")
        Set attrName = xmlDoc.createAttribute("Name")
        attrName.Text = templateName
        eleTemplate.setAttributeNode attrName
        Set attrDes = xmlDoc.createAttribute("Description")
        attrDes.Text = templateDes
        eleTemplate.setAttributeNode attrDes
        Set attrExtData = xmlDoc.createAttribute("ExtensionData")
        attrExtData.Text = templateExtData
        eleTemplate.setAttributeNode attrExtData
        Set attrDWMName = xmlDoc.createAttribute("DWMName")
        attrDWMName.Text = templateDWMName
        eleTemplate.setAttributeNode attrDWMName
        Set attrDWMData = xmlDoc.createAttribute("DWMData")
        attrDWMData.Text = templateDWMData
        eleTemplate.setAttributeNode attrDWMData
        objRoot.appendChild eleTemplate
    End If
  Next

  Set objIntro = xmlDoc.createProcessingInstruction ("xml","version='1.0'")  
  xmlDoc.insertBefore objIntro,xmlDoc.childNodes(0)
  
  strDestPath = GetDestPath()
  xmlDoc.Save strDestPath

  'FileData = ReadFile(strDestPath)

  'GetOfficialTemplateList = FileData

  'DeleteFile(strDestPath)

  GetOfficialTemplateList = ""

END FUNCTION

FUNCTION UpdateOfficialTemplate(xmlTemplateList)

  resultInit = InitObject()
  If resultInit <> "" Then
    UpdateOfficialTemplate = resultInit
    Exit Function
  End If

  DIM templateMgr
  DIM templateColl
  DIM templateObj

  SET templateMgr = config_manager.RightsTemplatePolicy

  SET templateColl = templateMgr.RightsTemplateCollection
  If IsNull(templateColl) Then
    UpdateOfficialTemplate = GenErrXML("Fail to get rights template collection.")
    Exit Function
  End If

  Set xmlDoc = CreateObject("Microsoft.XMLDOM")
  xmlDoc.async = false
  xmlDoc.loadXML(xmlTemplateList)

  DIM templateNameGet
  templateNameGet = ""
  DIM templateExtData
  templateExtData = ""
  DIM templateDWMData
  templateDWMData = ""
  DIM templateDWMName
  templateDWMName = ""

  Set colNodes = xmlDoc.selectNodes("/TemplateList/Template")
  For Each objNode in colNodes
    templateNameGet = objNode.Attributes.getNamedItem("Name").Text
    templateExtData = objNode.Attributes.getNamedItem("ExtensionData").Text
    templateDWMName = objNode.Attributes.getNamedItem("DWMName").Text
    templateDWMData = objNode.Attributes.getNamedItem("DWMData").Text

    Exit For
  Next

  'UpdateOfficialTemplate = "Name: " & templateNameGet & "Ext Data: " & templateExtData & "DWM Name: " & templateDWMName & "DWM Data: " & templateDWMData

  DIM nCount
  nCount = templateColl.Count
  For i=0 to nCount-1
    SET templateObj = templateColl.Item(i)

    DIM templateName
    templateName = templateObj.Summaries.Item(0).Name

    If StrComp(templateName, templateNameGet, 1) = 0 Then
        
        DIM appDataItems
        SET appDataItems = templateObj.ApplicationSpecificDataItems
        DIM nAppDataCount

        nAppDataCount = appDataItems.Count        
        For j=0 to nAppDataCount-1
          SET appDataItem = appDataItems.Item(j)
          DIM appDataName1
          appDataName1 = appDataItem.Name

          If StrComp(appDataName1, "FXRMSExtension", 1) = 0 Then
            appDataItems.RemoveAt(j)
            Exit For
          End If
        Next    

        nAppDataCount = appDataItems.Count
        For k=0 to nAppDataCount-1
          SET appDataItem = appDataItems.Item(k)
          DIM appDataName2
          appDataName2 = appDataItem.Name

          If InStr(appDataName2, "FXRMSDWM-") Then
            appDataItems.RemoveAt(k)
            Exit For
          End If
        Next    

        IF templateExtData <> "" Then
          SET appData1 = CreateObject( "Microsoft.RightsManagementServices.Admin.ApplicationSpecificDataItem")
          appData1.Name = "FXRMSExtension"
          appData1.Value = templateExtData
          templateObj.ApplicationSpecificDataItems.Add(appData1)
        End If
        
        IF templateDWMName <> "" And templateDWMData <> "" Then
          SET appData2 = CreateObject( "Microsoft.RightsManagementServices.Admin.ApplicationSpecificDataItem")
          appData2.Name = templateDWMName
          appData2.Value = templateDWMData
          templateObj.ApplicationSpecificDataItems.Add(appData2)
        End If

        templateColl.Update(templateObj)

    Exit For
    End If
  Next

END FUNCTION

FUNCTION GetDestPath()
  Const ssfAPPDATA = &H1A
  Set oShell = CreateObject("Shell.Application")
  strHomeFolder = oShell.NameSpace(ssfAPPDATA).Self.Path

  strDestPath = strHomeFolder & "\Foxit Software"
  CreateFolder(strDestPath)
  strDestPath = strHomeFolder & "\Foxit Software\RMS"
  CreateFolder(strDestPath)
  strDestPath = strHomeFolder & "\Foxit Software\RMS\Temp"
  CreateFolder(strDestPath)

  strDestPath = strHomeFolder & "\Foxit Software\RMS\Temp\TemplateList.xml"

  GetDestPath = strDestPath
END FUNCTION

' *******************************************************************
' Create a folder if not exist.

SUB CreateFolder(Folder)
  Set fso = CreateObject("scripting.FileSystemObject")
    If fso.FolderExists(Folder) <> true then
       fso.CreateFolder(Folder)
    End If
  Set fso = Nothing
END SUB

' *******************************************************************
' Read file data.

FUNCTION ReadFile(FilePath)
  Dim FileData
  Set fso = CreateObject("scripting.FileSystemObject")
    If fso.FileExists(FilePath) then
        Set myfile = fso.openTextFile(FilePath, 1, false)
        If myfile.AtEndOfStream<>true then
            FileData = myfile.ReadAll
        End If   
        myfile.close 
        Set myfile = Nothing 
    End If
    Set fso = Nothing
  ReadFile = FileData
END FUNCTION

' *******************************************************************
' Save file data.

FUNCTION SaveFile(FilePath, FileData)
  Set fso = CreateObject("scripting.FileSystemObject")
    
  Set myfile = fso.openTextFile(FilePath, 2, true)
  If IsNull(myfile)<>true then
      myfile.Write FileData
  End If   
  myfile.close 
  Set myfile = Nothing 
    
  Set fso = Nothing
  SaveFile = ""
END FUNCTION

' *******************************************************************
' Delete a file.

SUB DeleteFile(FilePath)
  Set fso = CreateObject("scripting.FileSystemObject")
    If fso.FileExists(FilePath) then
       fso.DeleteFile(FilePath)
    End If
  Set fso = Nothing
END SUB

FUNCTION GenErrXML(errorDes)
  Set xmlDoc = CreateObject("Microsoft.XMLDOM")
  Set objRoot = xmlDoc.createElement("TemplateList")  
  xmlDoc.appendChild objRoot

  Set eleError = xmlDoc.createElement("Error")
  Set attrDes = xmlDoc.createAttribute("Description")
  attrDes.Text = errorDes
  eleError.setAttributeNode attrDes
  objRoot.appendChild eleError

  Set objIntro = xmlDoc.createProcessingInstruction ("xml","version='1.0'")  
  xmlDoc.insertBefore objIntro,xmlDoc.childNodes(0)

  strDestPath = GetDestPath()
  xmlDoc.Save strDestPath

  'FileData = ReadFile(strDestPath)

  'GenErrXML = FileData

  'DeleteFile(strDestPath)
   GenErrXML = "Error"
END FUNCTION

GetOfficialTemplateList()